Skip to main content
This is the React InstantSearch v7 documentation. If you’re upgrading from v6, see the upgrade guide. If you were using React InstantSearch Hooks, this v7 documentation applies—just check for necessary changes. To continue using v6, you can find the archived documentation.
Signature
<InfiniteHits
  // Optional props
  hitComponent={({ hit }) => JSX.Element}
  showPrevious={boolean}
  transformItems={function}
  cache={object}
  classNames={object}
  translations={object}
  ...props={ComponentProps<'div'>}
/>

Import

JavaScript
import { InfiniteHits } from "react-instantsearch";

See this widget in action

Preview this widget and its behavior.

About this widget

The <InfiniteHits> widget displays a list of results with a “Show more” button at the bottom of the list. As an alternative to this approach, the infinite scroll guide describes how to create an automatically scrolling infinite hits experience. See also: Searches without results
You can also create your own UI with useInfiniteHits.

Examples

import React from "react";
import { liteClient as algoliasearch } from "algoliasearch/lite";
import { InstantSearch, InfiniteHits } from "react-instantsearch";

const searchClient = algoliasearch("YourApplicationID", "YourSearchOnlyAPIKey");

function Hit({ hit }) {
  return JSON.stringify(hit);
}

function App() {
  return (
    <InstantSearch indexName="instant_search" searchClient={searchClient}>
      <InfiniteHits hitComponent={Hit} />
    </InstantSearch>
  );
}

Props

hitComponent
(props: { hit: THit; sendEvent: SendEventForHits }) => JSX.Element
required
A component that renders each hit from the results. It receives a hit and a sendEvent (for insights) prop.When not provided, the widget displays the hit as a JSON string.
JavaScript
<InfiniteHits hitComponent={({ hit }) => hit.objectID} />;
bannerComponent
((props: { banner: SearchResults['renderingContent']['widgets']['banners'][0] }) => JSX.Element) | false
A component that renders the banner data on the renderingContent property from the Algolia response. It overrides the default banner rendering.When false, the widget does not render the banner.
JavaScript
// Override the default banner rendering
<InfiniteHits
  // ...
  bannerComponent={({ banner }) => <img src={banner.image.urls[0].url} />}
/>
// Disable the banner rendering
<InfiniteHits
  // ...
  bannerComponent={false}
/>
showPrevious
boolean
default:true
Enable the button to load previous results.
JavaScript
<InfiniteHits
  // ...
  showPrevious={false}
/>;
escapeHTML
boolean
default:true
Whether to escape HTML tags from hits string values.
JavaScript
<InfiniteHits
  // ...
  escapeHTML={false}
/>;
transformItems
(items: object[], metadata: { results: SearchResults }) => object[]
A function that receives the list of items before they are displayed. It should return a new array with the same structure. Use this to transform, filter, or reorder the items.The function also has access to the full results data, including all standard response parameters and parameters from the helper, such as disjunctiveFacetsRefinements.If you transform an attribute you’re using with the <Highlight> widget, you must also transform the corresponding item._highlightResult[attribute].value.
// Using only items
const transformItems = (items) => {
  return items.map((item) => ({
    ...item,
    label: item.name.toUpperCase(),
  }));
};

// Using items and results
const transformItems = (items, { results }) => {
  return items.map((item, index) => ({
    ...item,
    position: { index, page: results.page },
  }));
};

function Search() {
  return (
    <InfiniteHits
      // ...
      transformItems={transformItems}
    />
  );
}
cache
InfiniteHitsCache
The widget caches all loaded hits. By default, it uses its own internal in-memory cache implementation. Alternatively, use sessionStorage to retain the cache even if users reload the page.You can also implement your own cache object with read and write methods. This can be handy if you need to persist the data across sessions or if you expect the cached data to grow larger than the browser’s 5 MB allowed storage.
import { createInfiniteHitsSessionStorageCache } from "instantsearch.js/es/lib/infiniteHitsCache";

const sessionStorageCache = createInfiniteHitsSessionStorageCache();

<InfiniteHits
  // ...
  cache={sessionStorageCache}
/>;
classNames
Partial<InfiniteHitsClassNames>
The CSS classes you can override and pass to the widget’s elements. It’s useful to style widgets with class-based CSS frameworks like Bootstrap or Tailwind CSS.
  • root. The widget’s root element.
  • emptyRoot. The root element without results.
  • list. The list of results.
  • item. The list items.
  • loadPrevious. The “Load previous” button.
  • disabledLoadPrevious. The “Load previous” button when there are no previous results to load.
  • loadMore. The “Load more” button.
  • disabledLoadMore. The “Load more” button when there are no more results to load.
  • bannerRoot. The root element of the banner.
  • bannerImage. The image element of the banner.
  • bannerLink. The anchor element of the banner.
JavaScript
<InfiniteHits
  // ...
  classNames={{
    root: "MyCustomInfiniteHits",
    list: "MyCustomInfiniteHitsList MyCustomInfiniteHitsList--subclass",
  }}
/>;
translations
Partial<InfiniteHitsTranslations>
A dictionary of translations to customize the UI text and support internationalization.
  • showPreviousButtonText. The text for the “Show previous” button.
  • showMoreButtonText. The text for the “Show more” button.
JavaScript
<InfiniteHits
  // ...
  translations={{
    showPreviousButtonText: "Load previous results",
    showMoreButtonText: "Load more results",
  }}
/>;
...props
React.ComponentProps<'div'>
Any <div> prop to forward to the widget’s root element.
JavaScript
<InfiniteHits
  // ...
  className="MyCustomInfiniteHits"
  title="My custom title"
/>;

Hook

React InstantSearch let you create your own UI for the <InfiniteHits> widget with useInfiniteHits. Hooks provide APIs to access the widget state and interact with InstantSearch. The useInfiniteHits Hook accepts parameters and returns APIs. It must be used inside the <InstantSearch> component.

Usage

First, create your React component:
JavaScript
import { useInfiniteHits } from "react-instantsearch";

function CustomInfiniteHits(props) {
  const {
    items,
    currentPageHits,
    results,
    banner,
    isFirstPage,
    isLastPage,
    showPrevious,
    showMore,
    sendEvent,
  } = useInfiniteHits(props);

  return <>{/*Your JSX*/}</>;
}
Then, render the widget:
JavaScript
<CustomInfiniteHits {...props} />;

Parameters

Hooks accept parameters. You can either pass them manually or forward props from a custom component.
When passing functions to Hooks, ensure stable references to prevent unnecessary re-renders. Use useCallback() for memoization. Arrays and objects are automatically memoized.
escapeHTML
boolean
default:true
Whether to escape HTML tags from hits string values.
JavaScript
const infiniteHitsApi = useInfiniteHits({
  escapeHTML: false,
});
transformItems
(items: object[], metadata: { results: SearchResults }) => object[]
A function that receives the list of items before they are displayed. It should return a new array with the same structure. Use this to transform, filter, or reorder the items.The function also has access to the full results data, including all standard response parameters and parameters from the helper, such as disjunctiveFacetsRefinements.If you transform an attribute you’re using with the <Highlight> widget, you must also transform the corresponding item._highlightResult[attribute].value.
// Using only items
const transformItems = (items) => {
  return items.map((item) => ({
    ...item,
    label: item.name.toUpperCase(),
  }));
};

// Using items and results
const transformItems = (items, { results }) => {
  return items.map((item, index) => ({
    ...item,
    position: { index, page: results.page },
  }));
};

function InfiniteHits() {
  const infiniteHitsApi = useInfiniteHits({
    // ...
    transformItems,
  });

  return <>{/* Your JSX */}</>;
}
cache
InfiniteHitsCache
The Hook internally caches all loaded hits using its own internal in-memory cache implementation.The library provides another implementation using sessionStorage, which is more persistent and lets you restore the scroll position when you leave and come back to the search page.You can also provide your own implementation by providing a cache object with read and write methods.
import { createInfiniteHitsSessionStorageCache } from "instantsearch.js/es/lib/infiniteHitsCache";

const sessionStorageCache = createInfiniteHitsSessionStorageCache();

const infiniteHitsApi = useInfiniteHits({
  cache: sessionStorageCache,
});

APIs

Hooks return APIs, such as state and functions. You can use them to build your UI and interact with React InstantSearch.
items
THit[]
The matched hits returned from Algolia.This returns the combined hits for all the pages that have been requested so far. Use Algolia’s highlighting feature directly from the render function.
currentPageHits
THit[]
The matched hits from Algolia for the current page.Unlike the items parameter, this only returns the hits for the requested page. This can be useful if you want to customize how to add the new page of hits to the existing list.You can use Algolia’s highlighting feature directly from the render function.
results
SearchResults<THit>
The complete response from Algolia.It contains the hits, metadata about the page, the number of hits, and more. Unless you need to access metadata, use items instead.
banner
SearchResults['renderingContent']['widgets']['banners'][0]
The banner data from the renderingContent property in the Algolia response.
isFirstPage
boolean
Whether the first page of hits has been reached.
isLastPage
boolean
Whether the last page of hits has been reached.
showPrevious
() => void
Loads the previous page of hits.
showMore
() => void
Loads the next page of hits.
sendEvent
(eventType: string, hits: Hit | Hits, eventName?: string) => void
The function to send click or conversion events.The view event is automatically sent when this hook renders hits. Check the insights documentation to learn more.

Example

import React from "react";
import { useInfiniteHits } from "react-instantsearch";

function CustomInfiniteHits(props) {
  const { items, sendEvent, showPrevious, showMore, isFirstPage, isLastPage } =
    useInfiniteHits(props);

  return (
    <div>
      <button onClick={showPrevious} disabled={isFirstPage}>
        Show previous results
      </button>
      <ol>
        {items.map((hit) => (
          <li
            key={hit.objectID}
            onClick={() => sendEvent("click", hit, "Hit Clicked")}
            onAuxClick={() => sendEvent("click", hit, "Hit Clicked")}
          >
            <div style={{ wordBreak: "break-all" }}>
              {JSON.stringify(hit).slice(0, 100)}
            </div>
          </li>
        ))}
      </ol>
      <button onClick={showMore} disabled={isLastPage}>
        Show more results
      </button>
    </div>
  );
}

Click and conversion events

If the insights option is true, the InfiniteHits component automatically sends a click event with the following “shape” to the Insights API whenever users click a hit.
JSON
{
  "eventType": "click",
  "insightsMethod": "clickedObjectIDsAfterSearch",
  "payload": {
    "eventName": "Hit Clicked"
    // …
  },
  "widgetType": "ais.infiniteHits"
}
To customize this event, use the sendEvent function in your hitComponent and send a custom click event.
JavaScript
<InfiniteHits
  hitComponent={({ hit, sendEvent }) => (
    <div onClick={() => sendEvent("click", hit, "Product Clicked")}>
      <h2>
        <Highlight attributeName="name" hit={hit} />
      </h2>
      <p>{hit.description}</p>
    </div>
  )}
/>;
The sendEvent function also accepts an object as a fourth argument to send directly to the Insights API. You can use it, for example, to send special conversion events with a subtype.
JavaScript
<InfiniteHits
  hitComponent={({ hit, sendEvent }) => (
    <div>
      <h2>
        <Highlight attributeName="name" hit={hit} />
      </h2>
      <p>{hit.description}</p>
      <button
        onClick={() =>
          sendEvent("conversion", hit, "Added To Cart", {
            // Special subtype
            eventSubtype: "addToCart",
            // An array of objects representing each item added to the cart
            objectData: [
              {
                // The discount value for this item, if applicable
                discount: hit.discount || 0,
                // The price value for this item (minus the discount)
                price: hit.price,
                // How many of this item were added
                quantity: 2,
              },
            ],
            // The total value of all items
            value: hit.price * 2,
            // The currency code
            currency: "USD",
          })
        }
      >
        Add to cart
      </button>
    </div>
  )}
/>;
Use strings to represent monetary values in major currency units (for example, ‘5.45’). This avoids floating-point rounding issues, especially when performing calculations.
See also: Send click and conversion events with React InstantSearch
Last modified on May 7, 2026

You're viewing an archived version of our docs. Check out our current documentation →
InstantSearch / Angular / V4 / API reference

Ais-Infinite-Hits | Angular InstantSearch V4 (Deprecated)

Deprecated content
Angular InstantSearch is deprecated. Please use InstantSearch.js instead. For more information, see Migrating from Angular InstantSearch.

Signature

Signature
<ais-infinite-hits
  // Optional parameters
  showPrevious="boolean"
  showPreviousLabel="string"
  showMoreLabel="string"
  [transformItems]="function"
></ais-infinite-hits>

Import

1
2
3
4
5
6
7
8
import { NgAisInfiniteHitsModule } from 'angular-instantsearch';

@NgModule({
  imports: [
    NgAisInfiniteHitsModule,
  ],
})
export class AppModule {}

1. Follow additional steps in Optimize build size to ensure your code is correctly bundled.
2. This imports all the widgets, even the ones you don’t use. Read the Getting started guide for more information.

About this widget

The ais-infinite-hits widget displays a list of results with a “Show more” button at the bottom of the list. As an alternative to this approach, the infinite scroll guide describes how to create an automatically-scrolling infinite hits experience.

To configure the number of hits to show, use one of:

If there are no hits, you should display a message to users and clear filters so they can start over.

Examples

1
<ais-infinite-hits></ais-infinite-hits>

Props

showPrevious

Optional
Type: boolean

Enable the button to load previous results.

The button is only displayed if the routing option is enabled in ais-instantsearch and users aren’t on the first page. You can override this behavior with templates.

showPreviousLabel

Optional
Type: string

The label for the “Show previous” button.

showMoreLabel

Optional
Type: string

The label for the “Show more” button.

transformItems

Optional
Type: function

Receives the items and is called before displaying them. It returns a new array with the same “shape” as the original. This is helpful when transforming, removing, or reordering items.

The complete results data is also available, including all regular response parameters and helper parameters (for example, disjunctiveFacetsRefinements).

If you’re transforming an attribute with the highlight widget, you must transform item._highlightResult[attribute].value.

1
<ais-infinite-hits [transformItems]="transformItems"></ais-infinite-hits>
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
@Component({
  selector: "app-root",
  templateUrl: "./app.component.html",
})
export class AppComponent {
  // ...
  transformItems(items) {
    return items.map(item => ({
      ...item,
      isInCart: this.cart.includes(item.objectID)
    }));
  },

  /* or, combined with results */
  transformItems(items, { results }) {
    return items.map((item, index) => ({
      ...item,
      position: { index, page: results.page },
    }));
  },
}

hits

Optional
Type: object[]

The matched hits from the Algolia API. You can use Algolia’s highlighting feature with the highlight component.

results

Optional
Type: object

The complete response from the Algolia API. It contains the hits, metadata about the page, the number of hits, and so on. Unless you need to access metadata, use hits instead. You should also consider the stats widget if you want to build a widget that displays metadata about the search.

isFirstPage

Optional
Type: boolean

Indicates whether the first page of hits has been reached.

isLastPage

Optional
Type: boolean

Indicates whether the last page of hits has been reached.

showPrevious

Optional
Type: function

Loads the previous page of hits.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
<ais-infinite-hits>
  <ng-template
    let-hits="hits"
    let-results="results"
    let-refinePrevious="showPrevious"
  >
    <!-- No results message -->
    <div *ngIf="hits.length === 0">
      No results found matching <strong>{{results.query}}</strong>.
    </div>

    <!-- Show previous button template -->
    <button (click)="refinePrevious($event)">
      Show previous
    </button>

    <!-- Hit template -->
    <div *ngFor="let hit of hits">
      <h1>
        <ais-highlight
          attribute="title"
          [hit]="hit"
        ></ais-highlight>
      </h1>

      <p>{{hit.description}}</p>
    </div>
  </ng-template>
</ais-infinite-hits>

showMore

Optional
Type: function

Loads the next page of hits.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
<ais-infinite-hits>
  <ng-template
    let-hits="hits"
    let-results="results"
    let-refineNext="showMore"
  >
    <!-- No results message -->
    <div *ngIf="hits.length === 0">
      No results found matching <strong>{{results.query}}</strong>.
    </div>

    <!-- Hit template -->
    <div *ngFor="let hit of hits">
      <h1>
        <ais-highlight
          attribute="title"
          [hit]="hit"
        ></ais-highlight>
      </h1>

      <p>{{hit.description}}</p>
    </div>

    <!-- Show more button template -->
    <button (click)="refineNext($event)">
      Show more
    </button>
  </ng-template>
</ais-infinite-hits>

insights

Optional
Type: function

Sends Insights events.

  • method: string: the Insights method to be called. Only search-related methods are supported: 'clickedObjectIDsAfterSearch', 'convertedObjectIDsAfterSearch'.
  • payload: object: the payload to be sent.
    • eventName: string: the name of the event.
    • objectIDs: string[]: a list of objectIDs.
    • index?: string: the name of the index related to the click.
    • queryID?: string: the Algolia queryID found in the search response when clickAnalytics: true.
    • userToken?: string: a user identifier.
    • positions?: number[]: the position of the click in the list of Algolia search results. When not provided, index, queryID, and positions are inferred by the InstantSearch context and the passed objectIDs:
    • index by default is the name of index that returned the passed objectIDs.
    • queryID by default is the ID of the query that returned the passed objectIDs.
    • positions by default is the absolute positions of the passed objectIDs. It’s worth noting that each element of items has the following read-only properties:
  • __queryID: the query ID (only if clickAnalytics is true).
  • __position: the absolute position of the item.

    For more details on the constraints of each payload property, refer to the Insights API client documentation.

1
2
3
4
5
6
7
8
9
10
11
12
13
<ais-infinite-hits>
  <ng-template let-hits="hits" let-insights="insights">
    <div *ngFor="let hit of hits">
      <ais-highlight attribute="name" [hit]="hit"></ais-highlight>
      <button (click)="insights(
        'clickedObjectIDsAfterSearch',
        { eventName: 'Add to cart', objectIDs: [hit.objectID] }
      )">
        Add to cart
      </button>
    </div>
  </ng-template>
</ais-infinite-hits>